unit ODBClist;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Registry;

type
  TODBClist = class(TComponent)
  private
    { Private declarations }
    sl : TStrings;
    FFiltered : boolean;
    FFilter : String;
    procedure SetList( Value : TStrings );
  protected
    { Protected declarations }
  public
    constructor Create( AOwner: TComponent ); override;
    destructor Destroy; override;
    procedure Fill;
  published
    property DSNList: TStrings read sl write SetList;
    property Filtered : boolean read FFiltered write FFiltered;
    property Filter : String read FFilter write FFilter;
  end;

procedure Register;

implementation

procedure TODBClist.Fill;
var
  ini : TRegistry;
  StrList  : TStrings;
  i : Integer;
  s : String;
begin
  sl := TStringList.Create;
  ini := TRegistry.Create;
  ini.RootKey := HKEY_CURRENT_USER;
  ini.OpenKey( 'Software\ODBC\ODBC.INI\ODBC Data Sources', False );
  StrList := TStringList.Create;
  ini.GetValueNames( StrList );
  for i:=0 to StrList.Count-1 do
  begin
    s := UpperCase( ini.ReadString( StrList.Strings[i] ) );
    if not FFiltered then sl.Add( StrList.Strings[i] );
    if (Pos( UpperCase(FFilter), s ) <> 0) and (FFiltered) then
        sl.Add( StrList.Strings[i] );
  end;
  ini.Free;
  StrList.Free;
end;

procedure TODBClist.SetList( Value : TStrings );
begin
  sl.Assign( Value );
end;

constructor TODBClist.Create( AOwner: TComponent );
begin
  inherited Create( AOwner );
end;

destructor TODBClist.Destroy;
begin
  sl.Free;
  inherited;
end;

procedure Register;
begin
  RegisterComponents('MIKE', [TODBClist]);
end;

end.
